/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the GetCveRecordResponseContainersCnaAffectedVersionsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetCveRecordResponseContainersCnaAffectedVersionsInner{}

// GetCveRecordResponseContainersCnaAffectedVersionsInner struct for GetCveRecordResponseContainersCnaAffectedVersionsInner
type GetCveRecordResponseContainersCnaAffectedVersionsInner struct {
	Version *string `json:"version,omitempty"`
	Status *string `json:"status,omitempty"`
}

// NewGetCveRecordResponseContainersCnaAffectedVersionsInner instantiates a new GetCveRecordResponseContainersCnaAffectedVersionsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetCveRecordResponseContainersCnaAffectedVersionsInner() *GetCveRecordResponseContainersCnaAffectedVersionsInner {
	this := GetCveRecordResponseContainersCnaAffectedVersionsInner{}
	return &this
}

// NewGetCveRecordResponseContainersCnaAffectedVersionsInnerWithDefaults instantiates a new GetCveRecordResponseContainersCnaAffectedVersionsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetCveRecordResponseContainersCnaAffectedVersionsInnerWithDefaults() *GetCveRecordResponseContainersCnaAffectedVersionsInner {
	this := GetCveRecordResponseContainersCnaAffectedVersionsInner{}
	return &this
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) GetVersion() string {
	if o == nil || IsNil(o.Version) {
		var ret string
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) GetVersionOk() (*string, bool) {
	if o == nil || IsNil(o.Version) {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) HasVersion() bool {
	if o != nil && !IsNil(o.Version) {
		return true
	}

	return false
}

// SetVersion gets a reference to the given string and assigns it to the Version field.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) SetVersion(v string) {
	o.Version = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *GetCveRecordResponseContainersCnaAffectedVersionsInner) SetStatus(v string) {
	o.Status = &v
}

func (o GetCveRecordResponseContainersCnaAffectedVersionsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetCveRecordResponseContainersCnaAffectedVersionsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Version) {
		toSerialize["version"] = o.Version
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	return toSerialize, nil
}

type NullableGetCveRecordResponseContainersCnaAffectedVersionsInner struct {
	value *GetCveRecordResponseContainersCnaAffectedVersionsInner
	isSet bool
}

func (v NullableGetCveRecordResponseContainersCnaAffectedVersionsInner) Get() *GetCveRecordResponseContainersCnaAffectedVersionsInner {
	return v.value
}

func (v *NullableGetCveRecordResponseContainersCnaAffectedVersionsInner) Set(val *GetCveRecordResponseContainersCnaAffectedVersionsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableGetCveRecordResponseContainersCnaAffectedVersionsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableGetCveRecordResponseContainersCnaAffectedVersionsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetCveRecordResponseContainersCnaAffectedVersionsInner(val *GetCveRecordResponseContainersCnaAffectedVersionsInner) *NullableGetCveRecordResponseContainersCnaAffectedVersionsInner {
	return &NullableGetCveRecordResponseContainersCnaAffectedVersionsInner{value: val, isSet: true}
}

func (v NullableGetCveRecordResponseContainersCnaAffectedVersionsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetCveRecordResponseContainersCnaAffectedVersionsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


